#!/usr/bin/env ruby
#
# $Id: util2ch.rb,v 1.24 2003/02/23 01:19:56 Yuukis Exp $
#
#

require 'nkf'
require 'net/http'
Net::HTTP.version_1_2

BBSMenuFile = "#{Root}bbsmenu.html"
S = 'subject.txt'
RubyTooOld =<<TooOld

C.i. System Info:
Rubyɸźե饤֥net/http.rbΥС󤬸Ť褦Ǥ
datcacheݻԶ礬ФޤΤǡǿǤؤ뤳Ȥ򤪴ᤷޤ
TooOld

module InfoUtil
	def lastInfoRead(file)
	# def infoRead(info)
		fh = open(file)
		last = fh.read
		last.sub!('Last-Modified: ', '')
		last.chomp!
		fh.close
		return(last)
	end

	def lastInfoWrite(str, file)
	# def infoWrite(str, info)
		last = "Last-Modified: #{str}\n"
		fh = open(file, 'w')
		fh.write last
		fh.close
	end
end

module Profile
	def profileRead
	# def getProfile
		return('unix') unless File.exist?("#{Root}profile")
		var = {}
		profile = IO.readlines("#{Root}profile")
		profile.each {|line|
			a = line.split("=")
			key = a.shift
			value = a.to_s.chomp
			var[key]= value
		}
		return(var['board'])
	end

	def profileWrite(board)
	# def setProfile(board)
		str = ''
		str << "board=#{board}\n"
		open("#{Root}profile", 'w').write str
	end
end

module NetUp
	def netUp
		server = 'wids.net'
		path = '/lab/CiRelease.dat'
		header = {}
		header['User-Agent']= MonazillaUA
		Net::HTTP.start(server, 80) {|http|
			response , = http.get(path, header)

			case response.code
			when '200'  # OK
				#puts response.code
				return([false, '']) if response.body =~ CiVersion
				return([true, response.body])
			else
				#puts 'Can\'t get. Network Problem ?'
				return([false, ''])
			end
		}
	end
end

class String
	def dat2str(lastnum)
		str = ''
		lastnum += 1
		self.each {|line|
			NKF.nkf('-exS', line).gsub!(/(.*)<>(.*)<>(.*)<>\s*(.*)\s*<>/) {
				str << "#{lastnum}: #{$1.dat2txt!} <#{$2}> : "
				#p $4
				str << "#{$3}\n\n#{$4.dat2txt!.addBlank}\n\n-----\n"
			}
			lastnum += 1
		}
		return(str)
	end

	def dat2txt!
		convertStrings = {  /\s*<br>\s*/ => "\n", 
							'&gt;' => '>',
							'&lt;' => '<',
							'&nbsp;' => ' ',
							# '&nbsp' => ' ',
							'&thinsp;' => ' ',
							'&amp;' => '&',
							'&quot;' => '"' }
		convertStrings.each {|from, to|
			self.gsub!(from, to)
			self.gsub!(/<a href=.*?>/, '')
			self.gsub!('</a>', '')
		}
		self
	end

	def addBlank
		results = ''
		self.each {|line|
			#line.gsub!(/^\s*/, '')
			results << ' ' + line
		}
		return(results)
	end
end

module HTTPGet
	include InfoUtil

	def parseUri2(uri)
		server = ''
		path = ''
		uri.sub(/http:\/\/(.*?)(\/.*)/) {
			server = $1
			path = $2
		}
		return([server, path])
	end
	
	def httpGetFile(from, to, info, gzip = false, bytes = false)
		header = {}
		header['User-Agent']= MonazillaUA
		header['If-Modified-Since']= lastInfoRead(info) if File.exist?(info)
		header['Accept-Encoding']= 'gzip' if gzip
		header['Range']= bytes if bytes

		server, path = parseUri2(from)
		Net::HTTP.start(server, 80) {|http|
			begin

			response , = http.get(path, header)
			case response.code
			when '304'  # Use Local Copy
				#puts response.code
				return([true, response])
			when '206'  # Partical Content
				if response.body[0] == 10
					return([true, response])
				else
					# "ABone" ?
					header.delete('Range')
					header.delete('If-Modified-Since')
					retry
				end
			when '200'  # OK
				#puts response.code
				return([true, response])
			else
				#puts 'Can\'t get. Network Problem ?'
				return([false, response])
			end
			rescue Net::ProtoRetriableError => err
				puts RubyTooOld
			end
		}
	end

	def httpGetandLastModify(from, to, info, gzip = false)
		result, response = httpGetFile(from, to, info, gzip)
		case response.code
		when '304'  # Use Local Copy
			#puts response.code
			return([true, response])
		when '200'  # OK
			#puts response.code
			if gzip
				fh = open("#{to}.gz", 'w')
			else
				fh = open(to, 'w')
			end
			fh.write response.body
				fh.close
			system "#{Zcat} #{to}.gz" if gzip
			lastInfoWrite(response.header['Last-Modified'], info)
			return([true, response])
		else
			#puts 'Can\'t get. Network Problem ?'
			return([false, response])
		end
	end
end

module BBSMenu
	include HTTPGet
	include InfoUtil

	def getBBSMenu(bbsmenuInfo = BBSMenuFile + '.info')
		result, response = httpGetandLastModify(BBSMenuURI, BBSMenuFile, bbsmenuInfo)
		return([result, response.code])
	end

	def parseBBSMenu
		bbsNameHash = {}
		getBBSMenu unless File.exist?(BBSMenuFile)
		file = NKF.nkf('-exS', IO.readlines(BBSMenuFile).join)
		file.gsub!(/.*<BR><BR><B>/m, '<BR><BR><B>')
		file.gsub!(/Ʊ.*/m, "Ʊ</A>\n")
		file.gsub!(/<br>/i, '')
		file.gsub!(/<\/B>.*/, '')
		file.gsub!(/^\n/, '')

		bbsmenu = []
		bbsHash = {}

		file.each {|line|
			if line =~ /^<B>/
				bbsmenu << [line.sub(/<B>/, '').chomp, 'C-']
			else
				line.sub!(/<a href=(.*)>(.*)<\/a>/i){ bbsmenu << [$2, $1] }
			end
		}
		bbsmenu.each {|balk, value|
			if value =~ /^http:\/\/(.*)\/(.*)\//
				bbsHash[$2]= $1
			end
		}

		if $cfg['favoriteBoards'] != []
			favorites = []
			$cfg['favoriteBoards'].each {|x|
				uri = "http://#{bbsHash[x]}/#{x}/"
				b = bbsmenu.flatten
				favorites << [b[b.index(uri) - 1], uri]
			}
			favorites.reverse_each {|a| bbsmenu.unshift(a) }
			bbsmenu.unshift(['Favorites', 'C-'])
		end
		$bbsHash = bbsHash
		return(bbsmenu)
	end

	def parseUri(uri)  # uri == http://pc.2ch.net/unix/
		server = ''
		board = ''
		uri.sub(/http:\/\/(.*)\/(.*)\/.*/) {
			server = $1
			board = $2
		}
		return([server, board])
	end
end

class BBSBoard
	include HTTPGet
	include InfoUtil

	def initialize(board)
		@server = $bbsHash[board]
		@board = board
		@bookmark = Bookmark.new(board)
		@abone = Abone.new(board)
	end

	def downloadSubjects
		Dir.mkdir("#{Root}#{@board}") unless File.exist?("#{Root}#{@board}")
		writeOldSubjectsDummy unless File.exist?("#{Root}#{@board}/#{S}")
		File.rename("#{Root}#{@board}/#{S}", "#{Root}#{@board}/#{S}.tmp")

		result, response = httpGetandLastModify("http://#{@server}/#{@board}/#{S}",
			"#{Root}#{@board}/#{S}", "#{Root}#{@board}/#{S}.last", true)

		# exit unless result  # 㳰ȯrescue٤

		case response.code
		when '304'
			File.rename("#{Root}#{@board}/#{S}.tmp", "#{Root}#{@board}/#{S}")
			return('Not Modified')
		when '200'
			File.rename("#{Root}#{@board}/#{S}.tmp", "#{Root}#{@board}/#{S}.old")
			fh = open("#{Root}#{@board}/#{S}", 'r')
			str = NKF.nkf('-exS', fh.read)
			fh.close
			fh = open("#{Root}#{@board}/#{S}", 'w')
			fh.write str
			fh.close
			if File.stat("#{Root}#{@board}/#{S}.old").size < 100
				fh = open("#{Root}#{@board}/#{S}.old", 'w')
				fh.write str
				fh.close
			end
			return('Update Done')
		end
	end

	def writeOldSubjectsDummy
		fh = open("#{Root}#{@board}/#{S}", 'w')
		fh.write "0000000000.dat<>util2ch (0)\n"
		fh.close
	end

	def parseSubjects(fn, word = nil, bookmark = false)
		subjects = []
		lines = IO.readlines("#{Root}#{@board}/#{fn}")
		lines.each {|thread|
			thread.sub!(/(.*)<>(.*)\((.*)\)/) {
				if word
					d = $1 ; f = $3 ; s = $2.dat2txt!
					subjects << [d, f, s] if s =~ /#{word}/ie
				elsif bookmark
					d = $1 ; f = $3 ; s = $2.dat2txt!
					subjects << [d, f, s] if @bookmark.bookmark?(d)
				else
					d = $1 ; f = $3 ; s = $2.dat2txt!
					subjects << [d, f, s] unless @abone.abone?(d)
				end
			}
		}
		return(subjects)
	end

	def getSubjects(get = false, word = false, statusfilter = false, bookmark = false)

		get = true unless File.exist?("#{Root}#{@board}/#{S}")
		if get
			downloadSubjects
		else
			return(parsedSubjectGet(word, statusfilter, bookmark)) if File.exist?("#{Root}#{@board}/#{S}.cache") 
		end

		results = []
		Dir.mkdir("#{Root}#{@board}/cache/") unless File.exist?("#{Root}#{@board}/cache/")
		caches = Dir.entries("#{Root}#{@board}/cache/")
		newSubjects = parseSubjects("#{S}", word, bookmark)
		writeOldSubjectsDummy unless File.exist?("#{Root}#{@board}/#{S}.cache")
		oldSubjects = parseSubjects("#{S}.old", word, bookmark)
		newSubjects.each {|th|
			old = []
			oldSubjects.each {|oth|
				old = oth if th[0] == oth[0]
			}
			if caches.index(th[0])
				th.unshift("C")
			else
				th.unshift(" ")
			end
			if old == []
				unless statusfilter
					th[0, 0]= "N"
					cached = cachedThread(th[2])
					th[4, 0]= cached
					th[2, 0]= cacheCompare(th[3], cached)
					results << th
				end
			elsif th[2].to_i > old[1].to_i
				th[0, 0]= "U"
				cached = cachedThread(th[2])
				th[4, 0]= cached
				th[2, 0]= cacheCompare(th[3], cached)
				results << th
			else
				unless statusfilter
					th[0, 0]= " "
					cached = cachedThread(th[2])
					th[4, 0]= cached
					th[2, 0]= cacheCompare(th[3], cached)
					results << th
				end
			end
		}
		parsedSubjectSave(results)
		return(results)
	end

	def findSubjects(word)
		results = []
		caches = Dir.entries("#{Root}#{@board}/cache/")
		newSubjects = parseSubjects("#{S}", word)
		oldSubjects = parseSubjects("#{S}.old", word)
		newSubjects.each {|th|
			old = []
			oldSubjects.each {|oth|
				old = oth if th[0] == oth[0]
			}
			if caches.index(th[0])
				th.unshift("C")
			else
				th.unshift(" ")
			end
			if old == []
				results << th.unshift("N")
			elsif th[2].to_i > old[2].to_i
				results << th.unshift("U")
			else
				results << th.unshift("")
			end
		}
		return(results)
	end

	def cachedThread(dat)
		return('') unless File.exist?("#{Root}#{@board}/cache/#{dat}")
		return(IO.readlines("#{Root}#{@board}/cache/#{dat}").size.to_s)
	end

	def cacheCompare(dat, cache)
		return('') if cache == ''
		return('=') if dat.to_i == cache.to_i
		return('+') if dat.to_i > cache.to_i
		return('?')
	end

	def parsedSubjectGet(word = false, statusfilter = false, bookmark = false)
		subjects = []
		array = IO.readlines("#{Root}#{@board}/#{S}.cache")
		array.each {|line|
			th = line.split('<>')
			th[6].gsub!("&lt;&gt;", "<>")
			if word
				subjects << th if th[6] =~ /#{word}/ie
			elsif statusfilter
				subjects << th if th[0] == 'U'
			elsif bookmark
				subjects << th if @bookmark.bookmark?(th[3])
			else
				subjects << th unless @abone.abone?(th[3])
			end
		}
		return(subjects)
	end

	def parsedSubjectSave(array)
		str = ''
		array.each {|th|
			th[6].gsub!("<>", "&lt;&gt;")
			str << th.join("<>") + "\n"
		}
		fh = open("#{Root}#{@board}/#{S}.cache", 'w')
		fh.write str
		fh.close
	end

	def cachedThreadSave(dat)
		str = ''
		oCache = open("#{Root}#{@board}/#{S}.cache")
		oldCache = oCache.read
		oCache.close

		oldCache.each {|th|
			if th =~ /#{dat}/
				a = th.split('<>')
				a[1]= 'C'
				a[2]= '='
				a[5]= a[4]
				th = a.join('<>')
			end
			str << th
		}

		nCache = open("#{Root}#{@board}/#{S}.cache", 'w')
		nCache.write str
		nCache.close
	end
end

class BBSThread
	include HTTPGet
	include InfoUtil

	def initialize(board, dat)
		@server = $bbsHash[board]
		@board = board
		@dat = dat
		@bookmark = Bookmark.new(board)
		@abone = Abone.new(board)
	end

	def getThread
		from = "http://#{@server}/#{@board}/dat/#{@dat}"
		to = "#{Root}#{@board}/cache/#{@dat}"
		info = "#{to}.last"

		unless File.exist?(to)
			File.unlink(to+'.last') if File.exist?(to+'.last')
			File.unlink(to+'.cache') if File.exist?(to+'.cache')
		end
		range = false
		if File.exist?(to)
			filesize = File.stat(to).size - 1
			range = "bytes=#{filesize}-"
		end
		cache = to+'.cache'

		result, response = httpGetFile(from, to, info, false, range)
		case response.code
		when '304'  # Use Local Copy
			unless File.exist?(cache)
				tmp = ''
				n = 0
				open(to, 'r') {|line|
					tmp << line.read.dat2str(n)
					n += 1
				}
				fh = open(cache, 'w')
				fh.write tmp if tmp
					fh.close
			end
		when '206'  # Partical Content
			if response.body[0] == 10
				n = IO.readlines(to).size
				fh = open(to, 'a+')
				tmp  = response.body[1,response.body.size-1]
				fh.write tmp if tmp
					fh.close
				if File.exist?(cache)
					fh = open(cache, 'a+')
					tmp = tmp.dat2str(n)
					fh.write tmp if tmp
						fh.close
				else
					tmp = ''
					n = 0
					open(to, 'r') {|line|
						tmp << line.read.dat2str(n)
						n += 1
					}
					fh = open(cache, 'w')
					fh.write tmp if tmp
						fh.close
				end
				lastInfoWrite(response.header['Last-Modified'], info)
			end
		when '200'  # OK
			fh = open(to, 'w')
			fh.write response.body
				fh.close
			fh = open(cache, 'w')
			tmp = response.body.dat2str(0)
			fh.write tmp if tmp
				fh.close
			lastInfoWrite(response.header['Last-Modified'], info)
		end

		fh = open("#{Root}#{@board}/cache/#{@dat}.cache", 'r')
		str = fh.read
		fh.close
		return(str)
	end

	def parseDat
		th = []
		open("#{Root}#{@board}/cache/#{@dat}") {|line|
			NKF.nkf('-exS', line.read).gsub!(/(.*)<>(.*)<>(.*)<>(.*)<>/) {
				th << { 'name' => $1.dat2txt!,
						'mail' => $2,
						'date' => $3,
						#'body' => $4.dat2txt!.addBlank }
						'body' => $4.dat2txt! }
				}
		}
		return(th)
	end

	def getFollowUp(num)
		a = IO.readlines("#{Root}#{@board}/cache/#{@dat}")
		return('No Match.') if num-1 > a.size
		return(a[num-1].dat2str(num-1))
	end

	def parsedDatSave(str)
		fh = open("#{Root}#{@board}/cache/#{@dat}.cache", 'w')
		fh.write str
		fh.close
	end

	def bookmark?
		@bookmark.bookmark?(@dat)
	end

	def addBookmark
		@bookmark.addBookmark(@dat)
	end

	def deleteBookmark
		@bookmark.deleteBookmark(@dat)
	end

	def abone?
		@abone.abone?(@dat)
	end

	def addUserAbone(title)
		@abone.addUserAbone(@dat, title)
	end
end

class Bookmark  # Abone Ǥ
	def initialize(board)
		@board = board
		update
	end

	def bookmark?(dat)
		return(@bookmark.include?(dat))
	end

	def update
		@bookmark = []
		if File.exist?("#{Root}#{@board}/bookmark.dat")
			a = IO.readlines("#{Root}#{@board}/bookmark.dat")
			a.each {|th| @bookmark << th.chomp }
		end
	end

	def addBookmark(dat)
		update
		@bookmark << dat.chomp
		write
	end

	def deleteBookmark(dat)
		update
		@bookmark.delete(dat)
		write
	end

	def write
		str = ''
		@bookmark.each {|line| str << line + "\n" }
		fh = open("#{Root}#{@board}/bookmark.dat", 'w')
		fh.write str
		fh.close
	end
end

class Abone
	def initialize(board)
		@board = board
		update
	end

	def abone?(dat)
		if @userAbone.assoc(dat)
			return(true)
		else
			return(false)
		end
	end

	def update
		@userAbone = []
		if File.exist?("#{Root}#{@board}/abone.dat")
			a = IO.readlines("#{Root}#{@board}/abone.dat")
			a.each {|th|
				x = th.chomp.split('<>')
				x[1].gsub!("&lt;&gt;", "<>")
				@userAbone << x
			}
		end
	end	

	def addUserAbone(dat, title)
		update
		@userAbone << [dat, title.gsub('<>', '&lt;&gt;')]
		write
	end	

	def write
		str = ''
		@userAbone.each {|a| str << a.join('<>') + "\n" }
		fh = open("#{Root}#{@board}/abone.dat", 'w')
		fh.write str
		fh.close
	end
end

class CookieExcepton < StandardError ; end
class TimeExcepton < StandardError ; end

module PostMessage2ch  # code from goRua 0.15(Pre). thanks.
	def convert_and_encode(str)
		str=NKF::nkf('-sxE',str)
		return str.gsub(/[^a-zA-Z0-9_.-]/n){sprintf('%%%02X',$&.unpack('C')[0]) }
	end

	def postMessage(server, board, thread, name, mailto, message)
		thread = thread.gsub('.dat', '')
		kakikomu='񤭤'
		kakikomu = convert_and_encode(kakikomu)
		name = convert_and_encode(name)
		mailto = convert_and_encode(mailto)
		message = convert_and_encode(message)
		num_of_trial = 0 
		time = Time.now.to_i.to_s
   
		header = {}
		header['User-Agent']= MonazillaUA
		header['X-2ch-UA']= MonazillaUA
		header['Referer']= "http://#{server}/test/read.cgi/#{board}/#{thread}/"
		# header['Referer']= "http://#{server}/#{board}/index2.html"
		header['Content-Type']= 'application/x-www-form-urlencoded'
		header['Cookie']= "NAME=#{name};MAIL=#{mailto}"

		Net::HTTP.start(server, 80){ |http|
			begin
				response , = http.post( "/test/bbs.cgi",
				"submit=#{kakikomu}&FROM=#{name}&mail=#{mailto}&MESSAGE=#{message}&bbs=#{board}&key=#{thread}&time=#{time}",
				header)

				body = NKF::nkf('-exS',response.body)
				if response.code == '200'
				# navi2ch 1.5.1 
					if /񤭤ߤޤ/ =~ body
						return true, '񤭹(1)'
					elsif /ţңңϣҡ([^<]+)/ =~ body
						return false,"񤭤߼: #{$1}"
					elsif /ţңңϣҡ/ =~ body
						/<b>(.*?)<br>/ =~ body
						return false,"񤭤߼: #{$1}"
					elsif /åʤڤǤ/ =~ body || /\<!-- 2ch_X:cookie --\>/ =~ body
						num_of_trial += 1 
						if num_of_trial < 2
							header['Cookie'] += ';' + response['Set-Cookie']
							raise CookieExcepton
						end
						return false,'񤭤ߥ顼: åʤڤǤ'
					else
						STDERR.print body
						return false,'ν񤭤ߥ顼(1)'
					end
				else
					STDERR.print body
					return false,'ν񤭤ߥ顼(2)'
				end
			rescue Net::ProtoRetriableError
				return true, '쥯ȥڡ--餯񤭤--׳ǧ(2)'
			rescue TimeExcepton
				retry
			rescue CookieExcepton
				retry
			rescue
				# print "㳰ȯ񤭤ޤ줿ɤ狼ޤ\n"
				return false,'㳰ȯ񤭤ޤ줿ɤ狼ޤ'
			end
		}
	end

	def getAAList
		if File.exist?("#{Root}aa.list")
			fn = "#{Root}aa.list"
		else
			fn = "#{$cfg['scriptRoot']}aa.list"
		end
		aalist = IO.readlines(fn)
		return(aalist)
	end

	def postInfoRead(file)
	# def infoRead(info)
		return([$cfg['defaultName'], $cfg['defaultMailto']]) unless File.exist?(file)
		name = ''
		mail = ''
		fh = open(file)
		post = fh.read
		post.each {|line|
			case line
			when /^Name:(.*)/
				name = $1
			when /^Mail:(.*)/
				mail = $1
			end
		}
		fh.close
		name = '' if name.strip == ''
		mail = '' if mail.strip == ''
		return([name.sub(/^ /, ''), mail.sub(/^ /, '')])
	end

	def postInfoWrite(name, mail, file)
	# def infoWrite(name, mail, info)
		post = "Name: #{name}\nMail: #{mail}\n"
		fh = open(file, 'w')
		fh.write post
		fh.close
	end

end

# Util2ch.new.getBookmark('unix')
